/*
 *  Copyright (C) 2004 Karlheinz Klingbeil (lunqual)
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package de.lunqual.rzpro.items.bestellung;

import java.util.Calendar;

// java - pakete
/**
 *
 * @author  lunqual
 */
public class BestellungsCheckItem {

	int			rezeptur;
	double 		rest;
	int			einheit;
	String 		einheitString;
	boolean		lieferung;
	Calendar	lieferung_datum;

    public BestellungsCheckItem(int rezeptur,double rest,int einheit,String einheitString,boolean lieferung,Calendar lieferung_datum ) {
    	this.rezeptur=rezeptur;
    	this.rest=rest;
    	this.einheit=einheit;
    	this.einheitString=einheitString;
    	this.lieferung = lieferung;
    	this.lieferung_datum = lieferung_datum;
    }
	public int getRezeptur() {
		return rezeptur;
	}
	public double getRest() {
		return rest;
	}
	public int getEinheit() {
		return einheit;
	}

	public String getEinheitString() {
		return einheitString;
	}
	
	public boolean isAbgelaufen() {
		if(lieferung && lieferung_datum.before(Calendar.getInstance())) {
			return true;
		} else {
			return false;
		}
	}
}

